#include "CodaBase.h"
#include <vector>

#ifndef __CODA_VECT__
#define __CODA_VECT__

template <class Elem> 
class CodaVect : public CodaBase<Elem> {
 private:
        vector<Elem>  dati;
 public:
        CodaVect(){};
        virtual ~CodaVect(){};
        virtual bool enqueue(Elem e);
        virtual bool dequeue();
        virtual bool head(Elem &e);
        bool isempty();
};

template <class Elem> 
bool CodaVect<Elem>::enqueue(Elem e)
{     
     dati.push_back(e);
     return true;
};

template <class Elem> 
bool CodaVect<Elem>::dequeue() {
      
      typename vector<Elem>::iterator first = dati.begin();
     
     if (dati.empty())
        return false;
          
     dati.erase(first);
     return true;
};

template <class Elem> 
bool CodaVect<Elem>::head(Elem &e)
{
     if (!dati.empty())
     {
        e = dati[0]; 
        return true;
     } 
     else 
         return false;
};

template <class Elem> 
bool CodaVect<Elem>::isempty() 
{
    return dati.empty();
};      

#endif
